#include <iostream>
#include <cstddef>
#include <limits>

int main() {
    std::cout << "size_t is " << sizeof(size_t) * 8 << " bits\n";
    std::cout << "unsigned long is " << sizeof(unsigned long) * 8 << " bits\n";
    std::cout << "unsigned int is " << sizeof(unsigned int) * 8 << " bits\n";

    std::cout << "size_t max: " << std::numeric_limits<size_t>::max() << "\n";
    std::cout << "unsigned long max: " << std::numeric_limits<unsigned long>::max() << "\n";
    std::cout << "unsigned int max: " << std::numeric_limits<unsigned int>::max() << "\n";

    std::cout << "Is size_t same as unsigned long? " 
              << (std::is_same<size_t, unsigned long>::value ? "Yes" : "No") << "\n";
    std::cout << "Is size_t same as unsigned int? " 
              << (std::is_same<size_t, unsigned int>::value ? "Yes" : "No") << "\n";

    return 0;
}
